<template>
  <div>
    <h2>Application</h2>
    <el-row :gutter="20">
      <el-col :span="16" :offset="4"
        >
        <el-form
          label-position="top"
          label-width="100px"
          @submit.prevent="submit"
        >
          <el-form-item label="Clé secrète de votre API JSONBin.io">
            <el-input v-model="secretKey"></el-input>
          </el-form-item>
          <el-form-item label="ID votre bin">
            <el-input v-model="idBin"></el-input>
          </el-form-item>

          <el-button type="primary" native-type="submit" :loading="testing">Confirmer</el-button>

          <div class="text-center mt-5">
            <el-link href="https://jsonbin.io/" :underline="false" target="_blank">{} JSONBIN.io</el-link>
          </div>

        </el-form>
      </el-col>
    </el-row>
  </div>
</template>

<script>
  import { mapActions } from 'vuex'
  import { updateAxiosInstance } from '../services/TaskService.js'
  
  export default {
    methods: {
      ... mapActions({
        fetchAllTasks : 'tasks/fetchAllTasks',
        success: 'notifications/success',
        error: 'notifications/error'
      }),
      async submit() {
        this.testing = true
        localStorage.setItem('JSON_BIN_SECRET', this.secretKey)
        localStorage.setItem('JSON_BIN_ID', this.idBin)
        if(!this.secretKey)
          localStorage.removeItem('JSON_BIN_SECRET')

        if(!this.idBin)
          localStorage.removeItem('JSON_BIN_ID')

        try {
          updateAxiosInstance()
          await this.fetchAllTasks()
          localStorage.setItem('jsonBinAccess', true)
          this.success({
            title: 'JSONBin - succès',
            message: 'Vos clés son enregistré dans le navigateur'
          })
        } catch (error) {
          localStorage.removeItem('jsonBinAccess')
          this.error({
            title: 'JSONBin - Echoué',
            message: 'Votre combinaison de clés ne correspondent pas'
          })
        }
        this.testing = false
      }
    },
    data() {
      return {
        testing : false,
        secretKey : localStorage.getItem('JSON_BIN_SECRET'),
        idBin : localStorage.getItem('JSON_BIN_ID'),
      }
    },
  }
</script>